/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------------------------------------*/
/* Include related header files                                                                            */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "Driver\DrvADC.h"
#include "Driver\DrvUART.h"
#include "Driver\DrvGPIO.h"
#include "Driver\DrvSYS.h"

/*---------------------------------------------------------------------------------------------------------*/
/* Define Function Prototypes                                                                              */
/*---------------------------------------------------------------------------------------------------------*/
/* Main function */
void delay(void);
int main(void)
{
    STR_UART_T param;
    
    /* Unlock the locked registers before access */
    UNLOCKREG(x);

    /* System clock rate 12MHz */
    DrvSYS_Open(32000000);

    /* HCLK clock source. 0: external 4~24MHz crystal clock; 2: PLL clock; 4:internal 22.1184MHz RC oscillator */
    DrvSYS_SelectHCLKSource(2);

    /* Configure UART0 related pins */
    DrvGPIO_InitFunction(E_FUNC_UART0);
    
    /* Select UART Clock Source From 12MHz */
    DrvSYS_SelectIPClockSource(E_SYS_UART_CLKSRC,0);

    /* UART configuration */
    param.u32BaudRate        = 115200;
    param.u8cDataBits        = DRVUART_DATABITS_8;
    param.u8cStopBits        = DRVUART_STOPBITS_1;
    param.u8cParity          = DRVUART_PARITY_NONE;
    param.u8cRxTriggerLevel  = DRVUART_FIFO_1BYTES;
    param.u8TimeOut          = 0;

    DrvUART_Open(UART_PORT0, &param);

		DrvADC_Open(ADC_SINGLE_END,ADC_SINGLE_OP,2,EXTERNAL_12MHZ,0);
		DrvADC_DisableADCCmp0Int();
		DrvADC_DisableADCCmp1Int();
    while(1)
    {
			delay();
			DrvADC_StartConvert();
			while(ADC->ADSR.ADF==0);
			printf("Voltage: %.2f V\n",DrvADC_GetConversionData(1)*0.001221);
    }
}
void delay(void)
{
	int i;
	for (i=0; i<5000000; i++)
	{
	}
}
